#pragma once

#ifndef __5110INTF_H__
#define __5110INTF_H__

/* clock rate = 80 * output sample rate,     */
/* usually 640000 for 8000 Hz sample rate or */
/* usually 800000 for 10000 Hz sample rate.  */

typedef struct _tms5110_interface tms5110_interface;
struct _tms5110_interface
{
	int (*M0_callback)(const device_config *device);	/* function to be called when chip requests another bit */
	void (*load_address)(const device_config *device, int addr);	/* speech ROM load address callback */
};

WRITE8_DEVICE_HANDLER( tms5110_ctl_w );
WRITE8_DEVICE_HANDLER( tms5110_pdc_w );

READ8_DEVICE_HANDLER( tms5110_status_r );
int tms5110_ready_r(const device_config *device);

void tms5110_set_frequency(const device_config *device, int frequency);

DEVICE_GET_INFO( tms5110 );
DEVICE_GET_INFO( tms5100 );
DEVICE_GET_INFO( tms5110a );
DEVICE_GET_INFO( cd2801 );
DEVICE_GET_INFO( tmc0281 );
DEVICE_GET_INFO( cd2802 );
DEVICE_GET_INFO( m58817 );

#define SOUND_TMS5110 DEVICE_GET_INFO_NAME( tms5110 )
#define SOUND_TMS5100 DEVICE_GET_INFO_NAME( tms5100 )
#define SOUND_TMS5110A DEVICE_GET_INFO_NAME( tms5110a )
#define SOUND_CD2801 DEVICE_GET_INFO_NAME( cd2801 )
#define SOUND_TMC0281 DEVICE_GET_INFO_NAME( tmc0281 )
#define SOUND_CD2802 DEVICE_GET_INFO_NAME( cd2802 )
#define SOUND_M58817 DEVICE_GET_INFO_NAME( m58817 )

#endif /* __5110INTF_H__ */
